package MDELite6;

/**
 * a few utility routines used in MDELite6 tests, not in MDELite production code
 */
public class Utils {
    /**
     * a file filename is "x#y#z.q.r", where # denotes a windows (\) or unix
 (/) directory marker, and "." denotes the usual "dot" in file names
 This method returns a string array of a parsed file; in this
 case it would return ["x","y","z","q","r"].
     * 
     * see UtilsTest for examples
     * @param filename -- name of file to examine
     * @return parsing of the filename into a string array
     */
    public static String[] parseFileName(String filename) {
        String newname = filename.replace('.', '@');
        newname = newname.replace('\\', '@');
        newname = newname.replace('/', '@');
        newname = newname.replace("@@","@");
        String[] result = newname.split("@");
        return result;
    }
    
    
    /** 
     * given a parseFileName array ["x","y","z","q","r"],
     * endsWith returns true if its 2nd argument matches the postfix
     * of the input array; ex args = ["q","r"] will return true;
     * 
     * see UtilsTest for examples
     * 
     * @param result -- string array produced by parseFileName
     * @param args -- a list of strings to match with the end of result
     * @return true if args matches the latter part of result
     */
    public static boolean endsWith(String[] result, String... args) {
        int len = args.length ;
        int len2 = result.length;
        for (int i = 0; i<len ; i++) {
            String r = result[len2-len+ i];
            String s = args[i];
            if (!r.equals(s))
                return false;
        }
        return true;
    }
}
