/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package MDL;

import PrologDB.*;

/**
 *
 * InstanceOf is a program that takes two inputs, a schema and a db,
 * and confirms (or refutes) that the db conforms to the schema (sans constraints)
 */
public class InstanceOf {

    /**
     * standard marquee for an MDL program
     */
    public static void marquee() {
        System.err.println();
        System.err.format("Usage: %s <S>.schema.pl <Y>.<S>.pl\n", InstanceOf.class.getName());
        System.err.format("       confirms that database <Y> is an instance of <S>\n");
        System.exit(0);
    }

    /**
     * takes two inputs S.schema.pl Y.S.pl, and confirms or refutes
     * that the database conforms to the schema, not including schema constraints
     * @param args -- S.schema.pl, Y.S.pl
     */
    public static void main(String... args) {
        if (args.length != 2) {
            marquee();
        }

        DBSchema s = DBSchema.readSchema(args[0]);
        DB d = DB.readDataBase(args[1]);
        DBSchema s1 = d.getSchema();
        try {
            s.equalsEH(s1);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            System.err.format("schemas %s and %s do not match\n", args[0], args[1]);
        }
    }
}
