package MDL;

import PrologDB.DBSchema;
import java.io.PrintStream;


/**
 * OO2Schema translates S.ooschema.pl to S.schema.pl
 * that is, it propagates supertable attributes to subtable attributes
 */
public class OO2schema {

    
    /**
     * standard marquee for an MDL program
     */
    static void marquee() {
        String className = OO2schema.class.getName();
        System.err.println();
        System.err.format("Usage: %s <X>.ooschema.pl \n", className);
        System.err.format("       outputs file <X>.schema.pl\n", className);
        System.exit(1);
    }

    /**
     * asserts that fileName ends with ".ooschema.pl";
     * throws Error otherwise
     * @param fileName 
     */
    static void ooSchemaCheck(String fileName) {
        if (!fileName.endsWith(".ooschema.pl")) {
            throw new Error(String.format("prolog ooschema file does not end in '.ooschema.pl': %s\n", fileName));
        }
    }

    /**
     * reads X.ooschema.pl and outputs X.schema.pl by flattening -- propagating
     * columns of supertables to subtables
     * @param args -- X.ooschema.pl
     */
    public static void main(String... args) {
        if (args.length != 1) {
            marquee();
        }

        PrintStream ps = null;
        ooSchemaCheck(args[0]);
        DBSchema dbs = DBSchema.readSchema(args[0]);
        dbs.flatten();
        String front = args[0].replace(".ooschema.pl", ".schema.pl");
        try {
            ps = new PrintStream(front);
        } catch (Exception e) {
            throw new Error(String.format("Unable to create file %s\n", front));
        }
        dbs.print(ps);
    }
}
