package MDL;

import PrologDB.DB;

/**
 * MDL program that reads a database file and reports errors (other than
 * constraint violations)
 */
public class ReadDB {

    /**
     * standard marquee for MDL programs
     */
    static void marquee() {
        String className = ReadDB.class.getName();
        System.err.println();
        System.err.format("Usage: %s <x>.<schema>.pl\n",className);
        System.err.format("       reads database <x> of type <schema> and\n");
        System.err.format("       reports errors");
        System.exit(1);
    }

    /**
     * reads database X.S.pl and reports errors, if any;  Schema 
     * constraints not applied/evaluated.
     * 
     * @param args -- X.S.pl
     */
    public static void main(String... args) {
        if (args.length != 1) {
            marquee();
        }
        DB.readDataBase(args[0]);
    }
}
