package MDL;

import MDELite6.Constants;

/**
 * invokes violet class unparser
 */
public class VioletClassUnParser {
    
     /**
     * standard marquee for an MDL program
     */
    public static void marquee() {
        String className = VioletClassUnParser.class.getName();
        System.err.println();
        System.err.format("Usage: %s <X>.vpl.pl [<X>.class.violet]\n", className);
        System.err.format("       output file defaults to <X>.class.violet if unspecified \n");
        System.exit(1);
    }
    
    /**
     * invokes violetClassUnparser with arguments X.vpl.pl [Y.class.violet]
     * if optional argument is not present, it is assumed to be X.class.violet
     * 
     * @param args -- X.vpl.pl [Y.class.violet]
     */
    public static void main(String... args) {
        if (args.length < 1 || args.length > 2) {
            marquee();
        }
        
        if (args[1] == null) {
            MDL.Vm2t.main(args[0], Constants.homepath + "libvm/vpl2violet.vm");
        } else {
            MDL.Vm2t.main(args[0], Constants.homepath + "libvm/vpl2violet.vm", args[1]);
        }
    }
}
