package MDL;

import MDELite6.Constants;

/**
 * MDL program to invoke Yuml Class Unparser
 */
public class YumlClassUnParser {
    
    /**
     * standard marquee for an MDL program
     */
    public static void marquee() {
        String className = YumlClassUnParser.class.getName();
        System.err.println();
        System.err.format("Usage: %s <X>.ypl.pl [<Y>.yuml.yuml]\n", className);
        System.err.format("       output file defaults to <X>.yuml.yuml if unspecified \n");
        System.exit(1);
    }
    
    /**
     * invokes yuml class unparser with arguments X.ypl.pl [Y.yuml.yuml]
     * where if Y.yuml.yuml is absent, the target file is X.yuml.yuml
     * @param args - X.ypl.pl [Y.yuml.yuml]
     */
    public static void main(String... args) {
        if (args.length < 1 || args.length > 2) {
            marquee();
        }
        if (args[1] == null) {
            MDL.Vm2t.main(args[0], Constants.homepath + "libvm/ypl2yuml.vm");
        } else {
            MDL.Vm2t.main(args[0], Constants.homepath + "libvm/ypl2yuml.vm", args[1]);
        }
    }
}
