package PrologDB;

import MDELite6.Error;
import java.io.PrintStream;

/**
 * ErrorReport is a standard object to collect errors in evaluating
 * database constraints; it remembers a list of errors, and when its report
 * is printed, it throws Error if errors are reported
 * 
 */
public class ErrorReport {

    /**
     * this is the string accumulator of errors; initially it is empty.
     */
    String errorReport = "";
    int errorCount = 0;
    
    
    /**
     * returns a fresh ErrorReport object
     */
    public ErrorReport() {}

    /**
     * add errorMsg to report string
     * 
     * @param errorMsg -- errorMsg to report string
     */
    public void add(String errorMsg) {
        errorReport += errorMsg + "\n";
        errorCount++;
    }

    /**
     * print report to PrintStream out; if no errors are reported, printReport
     * returns; otherwise a Error is thrown
     * @param out -- printstream to output report
     */
    public void printReport(PrintStream out) {
        if (errorCount==0)
            return;
        out.println(errorReport);
        throw new Error(errorCount + " errors found");
    }
}
