package PrologParser;

/**
 * these are primitive lookahead tests in a prolog parser
 */
class PrimitiveLookAhead {

    /**
     * is c a digit?
     * @param c -- character to examine
     * @return is c a digit?
     */
    public boolean isDigit(char c) {
        return '0' <= c && c <= '9';
    }

    /**
     * is c a double-quote?
     * @param c -- character to examine
     * @return is c a double-quote?
     */
    public boolean isDoubleQuote(char c) {
        return c == '"';
    }

    /**
     * is c a letter?
     * @param c -- character to examine
     * @return is c a letter?
     */
    public boolean isLetter(char c) {
        return 'a' <= c && c <= 'z' || 'A' <= c && c <= 'Z';
    }

    /**
     * is c a letter or digit or underscore?
     * @param c -- character to examine
     * @return is c a letter or digit or underscore?
     */
    public boolean isLetterOrDigitOrUnderScore(char c) {
        return isLetter(c) || isDigit(c) || isUnderScore(c);
    }

    /**
     * is c a minus (negative) sign?
     * @param c -- character to examine
     * @return is c a minus (negative) sign?
     */
    public boolean isNegative(char c) {
        return c == '-';
    }

    /**
     * is c a single quote?
     * @param c -- character to examine
     * @return is c a single quote?
     */
    public boolean isSingleQuote(char c) {
        return c == '\'';
    }

    /**
     * is c a lowercase letter?
     * @param c -- character to examine
     * @return is c a lowercase letter?
     */
    public boolean isLowercaseLetter(char c) {
        return 'a' <= c && c <= 'z';
    }
    
    /**
     * is c a dot?
     * @param c -- character to examine
     * @return is c a dot?
     */
    public boolean isDot(char c) {
        return c == '.';
    }
    
    /**
     * is c an underscore?
     * @param c -- character to examine
     * @return is c an underscore?
     */
    public boolean isUnderScore(char c) {
        return c == '_';
    }
    
}
