package PrologProductions;

import PrologParser.LineToParse;

/**
 * a ColumnDecl is a sequence of names separated by commas
 */
public class ColumnDecl extends Token {
    
    public ColumnDecl() {
    }
    
    public ColumnDecl(LineToParse l) {
        super(l);
    }

    @Override
    public boolean canParse() {
        toBeParsed.AssertThereIsMoreToParse();
        char c = toBeParsed.peek();
        return  ((c == '"') || (toBeParsed.isLetter(c)));
    }

    @Override
    public void parse() {
        while (true) {
            toBeParsed.AssertThereIsMoreToParse();
            
            if (toBeParsed.peek() == ']')
                break;

            if (toBeParsed.peek() == '"') {
                toBeParsed.parseStep( new DoubleQuotedString(toBeParsed).canParse(), "double quoted string");
            } else {
                toBeParsed.parseStep( new Name(toBeParsed).canParse(), "name");
            }
            if (toBeParsed.peek() == ',') {
                toBeParsed.parseSkip(new Comma(toBeParsed).canParse(), "comma");
            } else {
                break;
            }
        }
    }

}
