package PrologProductions;

import PrologParser.LineToParse;

public class Fixed extends Token {

    /**
     * this is the string of a token that is expected
     */
    String pattern;
    
    
    /**
     * used when defining sentences -- a sequence of tokens
     * @param tok -- this is the string of a token that is expected
     **/
    public Fixed(String tok) {
        this.pattern = tok;
    }
    
    /**
     * used in parsing actual statements
     * 
     * @param tok -- this is the string of a token that is expected
     * @param l -- line to parse
     */
    public Fixed(String tok, LineToParse l) {
        super(l);
        pattern = tok;
    }

    @Override
    public boolean canParse() {
        return toBeParsed.toParse.startsWith(pattern) ? toBeParsed.returnSkip(pattern.length()) : false;
    }

    @Override
    public void parse() {
        toBeParsed.parseSkip(canParse(), "string \"" + pattern+"\"");
    }

}
