package PrologProductions;

import PrologParser.LineToParse;
import MDELite6.ParseException;

/**
 * a Number is a sequence of [-](digit)+[.(digit)+]
 */
public class Number extends Token {

    public Number() {
    }

    public Number(LineToParse l) {
        super(l);
    }

    @Override
    public boolean canParse() {
        boolean dotNotYetSeen = true;
        boolean oneDigitPastDot = false;
        int i, j;
        char c = toBeParsed.peek();
        boolean positive = !toBeParsed.isNegative(c);
        int start = positive ? 0 : 1;
        for (i = start; i < toBeParsed.toParse.length(); i++) {
            c = toBeParsed.toParse.charAt(i);
            if (toBeParsed.isDot(c) && dotNotYetSeen) {
                dotNotYetSeen = false;
                continue;
            }
            if (toBeParsed.isDigit(c)) {
                if (!dotNotYetSeen) {
                    oneDigitPastDot = true;
                }
                continue;
            }
            break;
        }
        if (!dotNotYetSeen && !oneDigitPastDot)
            throw new ParseException(toBeParsed.lineno, "ill-formed number starting with "+toBeParsed.toParse);
        return toBeParsed.returnResult(i);
    }

    @Override
    public void parse() {
        toBeParsed.parseStep(canParse(), "number");
    }
}
