package PrologProductions;

import PrologParser.LineToParse;

/**
 * TupleValues is a sequence of I(,I)*
 * where I = single-quoted-string | name | number ;
 */
public class TupleValues extends Token { // comma separated tuple values

    public TupleValues() {
    }

    public TupleValues(LineToParse l) {
        super(l);
    }
    
    @Override
    public boolean canParse() {
        toBeParsed.AssertThereIsMoreToParse();
        char c = toBeParsed.peek();
        return  ((c == '\'') || (toBeParsed.isDigit(c)) || (toBeParsed.isLetter(c)));
    }

    @Override
    public void parse() {
        while (true) {
            toBeParsed.AssertThereIsMoreToParse();
            char c = toBeParsed.peek();

            if (c == '\'') {
                toBeParsed.parseStep(new SingleQuotedString(toBeParsed).canParse(), "single quoted string");
            } else if (toBeParsed.isDigit(c)) {
                toBeParsed.parseStep(new Number(toBeParsed).canParse(), "number");
            } else {
                toBeParsed.parseStep(new Name(toBeParsed).canParse(), "name");
            }
            if (toBeParsed.peek() == ',') {
                toBeParsed.parseSkip(new Comma(toBeParsed).canParse(), "comma");
            } else {
                break;
            }
        }
    }
}
