package VioletClassParser;

import MDL.VioletClassParser;

/**
 * parse engine for VioletClassParser
 **/
public class Main {

    static String inputFile;

    /**
     * parse engine for VioletClassParser
     *
     * @see MDL.VioletClassParser
     * @param args -- same arguments as MDL.VioletClassParser
     */
    public static void main(String... args) {

        // Standard marquee test
        if (args.length != 2) {
            VioletClassParser.marquee();
        }
        if (!args[0].endsWith(".class.violet") || !args[1].endsWith(".vpl.pl")) {
            VioletClassParser.marquee();
        }

        inputFile = args[0];

        //Import XML data into Java objects
        Importer importer = new Importer(inputFile);
        importer.importNodesAndEdges();
        importer.assignParents();

        //Write our Violet DB file
        DBWriter dbWriter = new DBWriter(args[1], importer.getClassNodes(), importer.getClassEdges(),
                importer.getClassInterfaces(), importer.getVioletData(), importer.getNumNodes());
        dbWriter.generateVioletDB();
    }
}
