/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package BuildDocumentation;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map.Entry;
import org.junit.Test;

/**
 *
 * @author don
 */
public class BuildDocTest {

    static HashMap<String, String> harvested = null;


    
    @Test
    public void test1() {
        main("");
    }
    
    public static void main(String... args) {
        harvested = new HashMap<>();
        harvestCode("test/PrologDB/DocExamplesTest.java");
        String htmlFile = inhale("Docs/MDELite6DemoTemplate.htm");
        for (Entry<String, String> e : harvested.entrySet()) {
            String key = "---" + e.getKey() + "---";
            if (htmlFile.contains(key)) {
                htmlFile = htmlFile.replace(key, e.getValue());
            }
        }
        exhale(htmlFile, "Docs/MDELite6DemoPrograms.html");
    }

    static void harvestCode(String DocExamplesFileName) {
        LineNumberReader br;
        String example = null;
        String accum = null;
        int lineno = -1;
        try {
            br = new LineNumberReader(new InputStreamReader(new FileInputStream(new File(DocExamplesFileName))));
            String line;
            while ((line = br.readLine()) != null) {
                if (line.startsWith("///")) {
                    if (example == null) {
                        example = line.replace("///","").trim();
                        accum = "";
                        continue;
                    } else {
                        harvested.put(example, accum);
                        //System.out.println("harvested '"+example+"'");
                        example = null;
                        accum = null;
                        continue;
                    }
                }
                lineno = br.getLineNumber();

                if (example != null) {
                    accum = accum + line + "<br>";
                }
            }
            br.close();
        } catch (Exception e) {
            throw new RuntimeException("unable to parse " + DocExamplesFileName + " around line " + lineno + "\n" + e.getMessage());
        }
    }

    static String inhale(String HtmlFileName) {
        LineNumberReader br;
        String accum = "";
        try {
            br = new LineNumberReader(new InputStreamReader(new FileInputStream(new File(HtmlFileName))));
            String line;
            while ((line = br.readLine()) != null) {
                accum += line + "\n";
            }
            br.close();
        } catch (Exception e) {
            throw new RuntimeException("unable to read " + HtmlFileName + "\n" + e.getMessage());
        }
        return accum;
    }

    static void exhale(String data, String HtmlFileName) {
        try {
            PrintStream out = new PrintStream(HtmlFileName);
            out.println(data);
            out.close();
        } catch (Exception e) {
            throw new RuntimeException("unable to write " + HtmlFileName + "\n" + e.getMessage());
        }
    }
}
